# (c) 2002 Tony Monroe
package NetHirc::TerminalEvent;

use strict;

use Carp;

use NetHirc::Formats;

my %term_handlers = ();

sub new {
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my $self = { @_ };
    bless $self, $class;
}

sub add_handler {
    my $type = shift;
    my $code = shift;
    $term_handlers{$type} = $code;
}

sub remove_handler {
    my $type = shift;
    delete $term_handlers{$type};
}

sub handler {
    my $self = shift;
    my $egobj = shift;
    my $type = $self->type();
    my $code = $term_handlers{$type};
    if ($code) {
	$code->($egobj, $self);
    }
}

sub type { $_[0]->{'Type'}; }
sub args { $_[0]->{'Args'}; }

sub cmds {
    shift;
    return sort keys %term_handlers;
}

sub cmd {
    shift;
    return $term_handlers{$_[0]};
}

1;
